package preprocess;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class Wiki_google_get_time_series {

	public static void main(String[] args) throws FileNotFoundException,
			IOException {
		String path = "D:/experiment/sleep-beauty/rare-wiki-google/";
		String pathgoogleday = "D:/experiment/sleep-beauty/time-series-data/googleday.txt";
		BufferedWriter bwgoogleday = new BufferedWriter(new OutputStreamWriter(
				new FileOutputStream(pathgoogleday), "utf-8"));
		String pathwikipediaday = "D:/experiment/sleep-beauty/time-series-data/wikipediaday.txt";
		BufferedWriter bwwikipediaday = new BufferedWriter(
				new OutputStreamWriter(new FileOutputStream(pathwikipediaday),
						"utf-8"));

		String pathgoogleweek = "D:/experiment/sleep-beauty/time-series-data/googleweek.txt";
		BufferedWriter bwgoogleweek = new BufferedWriter(
				new OutputStreamWriter(new FileOutputStream(pathgoogleweek),
						"utf-8"));
		String pathwikipediaweek = "D:/experiment/sleep-beauty/time-series-data/wikipediaweek.txt";
		BufferedWriter bwwikipediaweek = new BufferedWriter(
				new OutputStreamWriter(new FileOutputStream(pathwikipediaweek),
						"utf-8"));

		String pathgooglemonth = "D:/experiment/sleep-beauty/time-series-data/googlemonth.txt";
		BufferedWriter bwgooglemonth = new BufferedWriter(
				new OutputStreamWriter(new FileOutputStream(pathgooglemonth),
						"utf-8"));
		String pathwikipediamonth = "D:/experiment/sleep-beauty/time-series-data/wikipediamonth.txt";
		BufferedWriter bwwikipediamonth = new BufferedWriter(
				new OutputStreamWriter(
						new FileOutputStream(pathwikipediamonth), "utf-8"));

		File[] filelist = new File(path).listFiles();
		Set<String> set1day = new HashSet<String>();
		Set<String> set2day = new HashSet<String>();
		Set<String> set1week = new HashSet<String>();
		Set<String> set2week = new HashSet<String>();
		Set<String> set1month = new HashSet<String>();
		Set<String> set2month = new HashSet<String>();
		Map<String, ArrayList<String>> mapgoogled = new HashMap<String, ArrayList<String>>();
		Map<String, HashSet<String>> mapgoogledset = new HashMap<String, HashSet<String>>();
		Map<String, ArrayList<String>> mapgooglew = new HashMap<String, ArrayList<String>>();
		Map<String, HashSet<String>> mapgooglewset = new HashMap<String, HashSet<String>>();
		Map<String, ArrayList<String>> mapgooglem = new HashMap<String, ArrayList<String>>();
		Map<String, HashSet<String>> mapgooglemset = new HashMap<String, HashSet<String>>();
		Map<String, ArrayList<String>> mapwikid = new HashMap<String, ArrayList<String>>();
		Map<String, HashSet<String>> mapwikidset = new HashMap<String, HashSet<String>>();
		Map<String, ArrayList<String>> mapwikiw = new HashMap<String, ArrayList<String>>();
		Map<String, HashSet<String>> mapwikiwset = new HashMap<String, HashSet<String>>();
		Map<String, ArrayList<String>> mapwikim = new HashMap<String, ArrayList<String>>();
		Map<String, HashSet<String>> mapwikimset = new HashMap<String, HashSet<String>>();
		Map<String, String> wiki = new HashMap<String, String>();
		Map<String, String> google = new HashMap<String, String>();

		for (File filei : filelist) {
			String name = filei.getName();
			if (name.contains("google")) {
				String pathin = filei.getAbsolutePath();
				BufferedReader br = new BufferedReader(new InputStreamReader(
						new FileInputStream(pathin), "utf-8"));
				String str = "";

				while ((str = br.readLine()) != null) {
					String[] si = str.split("\t");

					if (si.length != 6)
						System.out.println(si.length);
					String key = si[2].trim();
					String time = si[4].trim();
					google.put(key, si[3].trim());
					if (si[4].trim().length() == 10) {
						boolean flag = false;
						if (!mapgoogledset.containsKey(key)) {
							HashSet<String> set = new HashSet<String>();
							set.add(time);
							mapgoogledset.put(key, set);
							flag = true;
						} else {
							HashSet<String> set = mapgoogledset.get(key);
							if (!set.contains(time)) {
								set.add(time);
								mapgoogledset.put(key, set);
								flag = true;
							}
						}
						if (flag) {
							if (mapgoogled.containsKey(key)) {
								ArrayList<String> al = mapgoogled.get(key);
								al.add(si[5].trim());
								mapgoogled.put(key, al);
							} else {
								ArrayList<String> al = new ArrayList<String>();
								al.add(si[5].trim());
								mapgoogled.put(key, al);
							}
						}
						// if (!set1day.contains(si[3])) {
						// set1day.add(si[3]);
						// bwgoogleday.newLine();
						// bwgoogleday.append(si[3] + "\t" + si[5]);
						// } else {
						// bwgoogleday.append("\t" + si[5]);
						// }
					} else if (si[4].trim().length() == 23) {
						boolean flag = false;
						if (!mapgooglewset.containsKey(key)) {
							HashSet<String> set = new HashSet<String>();
							set.add(time);
							mapgooglewset.put(key, set);
							flag = true;
						} else {
							HashSet<String> set = mapgooglewset.get(key);
							if (!set.contains(time)) {
								set.add(time);
								mapgooglewset.put(key, set);
								flag = true;
							}
						}
						if (flag) {
							if (mapgooglew.containsKey(key)) {
								ArrayList<String> al = mapgooglew.get(key);
								al.add(si[5].trim());
								mapgooglew.put(key, al);
							} else {
								ArrayList<String> al = new ArrayList<String>();
								al.add(si[5].trim());
								mapgooglew.put(key, al);
							}
						}
						// if (!set1week.contains(si[3])) {
						// set1week.add(si[3]);
						// bwgoogleweek.newLine();
						// bwgoogleweek.append(si[3] + "\t" + si[5]);
						// } else {
						// bwgoogleweek.append("\t" + si[5]);
						// }
					} else if (si[4].trim().length() == 7) {
						boolean flag = false;
						if (!mapgooglemset.containsKey(key)) {
							HashSet<String> set = new HashSet<String>();
							set.add(time);
							mapgooglemset.put(key, set);
							flag = true;
						} else {
							HashSet<String> set = mapgooglemset.get(key);
							if (!set.contains(time)) {
								set.add(time);
								mapgooglemset.put(key, set);
								flag = true;
							}
						}
						if (flag) {
							if (mapgooglem.containsKey(key)) {
								ArrayList<String> al = mapgooglem.get(key);
								al.add(si[5].trim());
								mapgooglem.put(key, al);
							} else {
								ArrayList<String> al = new ArrayList<String>();
								al.add(si[5].trim());
								mapgooglem.put(key, al);
							}
						}
						// if (!set1month.contains(si[3])) {
						// set1month.add(si[3]);
						// bwgooglemonth.newLine();
						// bwgooglemonth.append(si[3] + "\t" + si[5]);
						// } else {
						// bwgooglemonth.append("\t" + si[5]);
						// }
					}

				}
				br.close();
				// System.out.println(pathin);

			} else if (name.contains("wikipedia")) {
				String pathin = filei.getAbsolutePath();
				BufferedReader br = new BufferedReader(new InputStreamReader(
						new FileInputStream(pathin), "utf-8"));
				String str = "";
				int c1 = 0;
				int c2 = 0;
				int c3 = 0;
				while ((str = br.readLine()) != null) {
					String[] si = str.split("\t");
					String key = si[2].trim();
					String time = si[4].trim();
					wiki.put(key, si[3].trim());
					if (si.length != 6)
						System.out.println(si.length);
					// System.out.println(si[4]);
					// System.out.println(si.length);

					if (si[4].trim().length() == 10) {
						boolean flag = false;
						if (!mapwikidset.containsKey(key)) {
							HashSet<String> set = new HashSet<String>();
							set.add(time);
							mapwikidset.put(key, set);
							flag = true;
						} else {
							HashSet<String> set = mapwikidset.get(key);
							if (!set.contains(time)) {
								set.add(time);
								mapwikidset.put(key, set);
								flag = true;
							}
						}
						if (flag) {
							if (mapwikid.containsKey(key)) {
								ArrayList<String> al = mapwikid.get(key);
								al.add(si[5].trim());
								mapwikid.put(key, al);
							} else {
								ArrayList<String> al = new ArrayList<String>();
								al.add(si[5].trim());
								mapwikid.put(key, al);
							}
						}
						// if (!set2day.contains(si[3])) {
						// set2day.add(si[3]);
						// bwwikipediaday.newLine();
						// bwwikipediaday.append(si[3] + "\t" + si[5]);
						// } else {
						// bwwikipediaday.append("\t" + si[5]);
						// }
					} else if (si[4].trim().length() == 23) {
						boolean flag = false;
						if (!mapwikiwset.containsKey(key)) {
							HashSet<String> set = new HashSet<String>();
							set.add(time);
							mapwikiwset.put(key, set);
							flag = true;
						} else {
							HashSet<String> set = mapwikiwset.get(key);
							if (!set.contains(time)) {
								set.add(time);
								mapwikiwset.put(key, set);
								flag = true;
							}
						}
						if (flag) {
							if (mapwikiw.containsKey(key)) {
								ArrayList<String> al = mapwikiw.get(key);
								al.add(si[5].trim());
								mapwikiw.put(key, al);
							} else {
								ArrayList<String> al = new ArrayList<String>();
								al.add(si[5].trim());
								mapwikiw.put(key, al);
							}
						}
						// if (!set2week.contains(si[3])) {
						// set2week.add(si[3]);
						// bwwikipediaweek.newLine();
						// bwwikipediaweek.append(si[3] + "\t" + si[5]);
						// } else {
						// bwwikipediaweek.append("\t" + si[5]);
						// }
					} else if (si[4].trim().length() == 7) {
						boolean flag = false;
						if (!mapwikimset.containsKey(key)) {
							HashSet<String> set = new HashSet<String>();
							set.add(time);
							mapwikimset.put(key, set);
							flag = true;
						} else {
							HashSet<String> set = mapwikimset.get(key);
							if (!set.contains(time)) {
								set.add(time);
								mapwikimset.put(key, set);
								flag = true;
							}
						}
						if (flag) {
							if (mapwikim.containsKey(key)) {
								ArrayList<String> al = mapwikim.get(key);
								al.add(si[5].trim());
								mapwikim.put(key, al);
							} else {
								ArrayList<String> al = new ArrayList<String>();
								al.add(si[5].trim());
								mapwikim.put(key, al);
							}
						}
						// if (!set2month.contains(si[3])) {
						// set2month.add(si[3]);
						// bwwikipediamonth.newLine();
						// bwwikipediamonth.append(si[3] + "\t" + si[5]);
						// } else {
						// bwwikipediamonth.append("\t" + si[5]);
						// }
					}
				}
				br.close();
				// System.out.println(pathin);
			}
		}
		for (String key : mapgoogled.keySet()) {
			ArrayList<String> al = mapgoogled.get(key);
			bwgoogleday.append(google.get(key));
			for (String ai : al) {
				bwgoogleday.append("\t" + ai);
			}
			bwgoogleday.newLine();
		}
		bwgoogleday.close();
		for (String key : mapgooglew.keySet()) {
			ArrayList<String> al = mapgooglew.get(key);
			bwgoogleweek.append(google.get(key));
			for (String ai : al) {
				bwgoogleweek.append("\t" + ai);
			}
			bwgoogleweek.newLine();
		}
		bwgoogleweek.close();
		for (String key : mapgooglem.keySet()) {
			ArrayList<String> al = mapgooglem.get(key);
			bwgooglemonth.append(google.get(key));
			for (String ai : al) {
				bwgooglemonth.append("\t" + ai);
			}
			bwgooglemonth.newLine();
		}
		bwgooglemonth.close();
		for (String key : mapwikid.keySet()) {
			ArrayList<String> al = mapwikid.get(key);
			bwwikipediaday.append(wiki.get(key));
			for (String ai : al) {
				bwwikipediaday.append("\t" + ai);
			}
			bwwikipediaday.newLine();
		}
		bwwikipediaday.close();
		for (String key : mapwikiw.keySet()) {
			ArrayList<String> al = mapwikiw.get(key);
			bwwikipediaweek.append(wiki.get(key));
			for (String ai : al) {
				bwwikipediaweek.append("\t" + ai);
			}
			bwwikipediaweek.newLine();
		}
		bwwikipediaweek.close();
		for (String key : mapwikim.keySet()) {
			ArrayList<String> al = mapwikim.get(key);
			if (al.size() > 84)
				System.out
						.println(wiki.get(key) + "\t" + al.size() + "\t" + al);
			bwwikipediamonth.append(wiki.get(key));
			for (String ai : al) {
				bwwikipediamonth.append("\t" + ai);
			}
			bwwikipediamonth.newLine();
		}
		bwwikipediamonth.close();
	}

}
