package statistic;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Map;

public class Simulation_fre_cdf {
	public static void main(String[] args) throws IOException, FileNotFoundException{
		String path = "D:/experiment/sleep-beauty/empirical/prediction/"; 
		File [] filelist = new File(path).listFiles();
		for(File file:filelist){
			String name = file.getName();
			if(name.endsWith("_fre_align_withrealp.txt")){
		//String pathin = "D:/experiment/sleep-beauty/empirical/prediction/wikipediaweek_fre_align.txt";
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(file),"utf-8"));
		Map<Integer,Integer> map = new HashMap<Integer,Integer>();
		Map<Integer,Integer> map1 = new HashMap<Integer,Integer>();
		String str = "";
		while((str=br.readLine())!=null){
			String[] s = str.split("\t");
			//String k = s[0];
			for(int i = 0;i<s.length;i++){
				if(map.containsKey(i)){
					int t = map.get(i);
					map.put(i, t+Integer.parseInt(s[i]));
				}else{
					map.put(i,Integer.parseInt(s[i]));
				}
				if(Integer.parseInt(s[i])!=0){
					if(map1.containsKey(i)){
						int t = map1.get(i);
						map1.put(i, t+1);
					}else{
						map1.put(i,1);
					}
				}else{
					if(!map1.containsKey(i)){
						map1.put(i,1);
					}
				}
			}
		}
		br.close();
		String pathout = "D:/experiment/sleep-beauty/empirical/prediction/"+name.substring(0,name.length()-24)+"_ave_align_withrealp.txt";
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(pathout),"utf-8"));
		String pathout1 = "D:/experiment/sleep-beauty/empirical/prediction/"+name.substring(0,name.length()-24)+"_cdf_align_withrealp.txt";
		BufferedWriter bw1 = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(pathout1),"utf-8"));
		
		DecimalFormat df = new DecimalFormat("0.0000");
		double sum = 0;
		for(int key = 0;key<map.size();key++){
			int t = map.get(key);
			System.out.println(key);
			double at = 1.0*t/map1.get(key);
			sum += at;
			bw.append(df.format(at)+"\n");
			bw1.append(df.format(sum)+"\n");
		}
		bw.close();
		bw1.close();
			}
		}
	}

}
