package util.math;

	import java.util.ArrayList;
	import java.util.List;

	/**
	 * λ,ʹÿҵKС㷨
	 * @author wangzejie
	 *
	 * @param <T>
	 */
	public class MediumFinder<T extends Comparable<T>> {
		private boolean bOdd;//Ƿż
		private int kv;//ڼֵ
		private List<T> medium = new ArrayList<T>();//λ
		/**
		 * һquicksort
		 * @param a
		 * @param low
		 * @param high
		 * @return
		 */
		private int partition(T a[], int low, int high) {
			T tmp = a[low];
			int i = low, j = high;
			while (i < j) {
				while (i < j && a[j].compareTo(tmp) >= 0){
					j--;
				}
				while (i < j && a[i].compareTo(tmp) <= 0){
					i++;
				}
				swap(a, i, j);
			}
			a[low] = a[i];
			a[i] = tmp;
			return i;
		}

		/**
		 * λõֵ
		 * @param a
		 * @param i
		 * @param j
		 */
		private void swap(T a[], int i, int j) {
			if(i == j){
				return;
			}
			T tmp = a[i];
			a[i] = a[j];
			a[j] = tmp;
		}
		
		/**
		 * λֵ
		 * @param a
		 * @return  λT󣬵żʱ㣬ʱһ
		 */
		public List<T> findMedium(T a[]){
			medium.clear();
			if(a.length == 1){
				medium.add(a[0]);
			}else if(a.length == 2){
				medium.add(a[0]);
				medium.add(a[1]);
			}else{
				bOdd = a.length % 2 == 0;
				kv = a.length / 2 + 1;
				findK(a, 0, a.length - 1, kv, -1);
			}
			return medium;
		}
		/**
		 * ѰҵKٵֵ
		 * @param a
		 * @param low
		 * @param high
		 * @param k
		 * @param prePart
		 */
		private void findK(T a[], int low, int high, int k, int prePart){
			if(low > high){
				return;
			}
			int pos = partition(a, low, high);
			int left = pos - low + 1;
			if(k > left){
				findK(a, pos + 1, high, k - left, pos);
			}
			else if(k < left){
				findK(a, low, pos - 1, k, prePart);
			}
			else{
				if(bOdd){
					T v1 = a[pos];
					T v2 = null;
					if(low >= pos){
						v2 = a[prePart];
					}else{
						v2 = findMax(a, low, pos - 1);
					}
					medium.add(v1);
					medium.add(v2);
				}else{
					medium.add(a[pos]);
				}
			}
		}
		/**
		 * ѰһΧڵֵ
		 * @param a
		 * @param low
		 * @param high
		 * @return
		 */
		private T findMax(T a[], int low, int high){
			T max = a[low];
			for(int i = low + 1; i <= high; i ++){
				if(a[i].compareTo(max) > 0){
					max = a[i];
				}
			}
			return max;
		}
	}


	/*public class Point implements Comparable<Point> {

		private double lng;
		private double lat;
		private double value;

		public double getLng() {
			return lng;
		}

		public void setLng(double lng) {
			this.lng = lng;
		}

		public double getLat() {
			return lat;
		}

		public void setLat(double lat) {
			this.lat = lat;
		}

		public double getValue() {
			return value;
		}

		public void setValue(double value) {
			this.value = value;
		}

		@Override
		public int compareTo(Point o) {
			double t = this.value - o.value;
			if (t > 0) {
				return 1;
			} else if (t < 0) {
				return -1;
			}
			return 0;
		}

	}*/
