package statistic;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Statistic_features {
	public static void main(String[] args) throws IOException,
			FileNotFoundException {
		// String[] dwmlist = { "week", "day", "month" };
		// String[] gw = { "google", "wikipedia" };
		// for (String gwi : gw)
		String pathin = "D:/experiment/sleep-beauty/empirical/sleep-feature/";
		// for (String dwm : dwmlist) {
		File[] filelist = new File(pathin).listFiles();
		List<String> listlr1 = new ArrayList<String>();
		List<String> listlr2 = new ArrayList<String>();
		
		List<Integer> listleftwide1_total = new ArrayList<Integer>();
		List<Integer> listrightwide1_total = new ArrayList<Integer>();
		List<Integer> listleftwide2_total = new ArrayList<Integer>();
		List<Integer> listrightwide2_total = new ArrayList<Integer>();
		for (File file : filelist) {
			// int kk = 3; // 5
			// double h = 0.5; // 1.5
			// String breakrate = "0.2";
			// String pathin =
			// "D:/data/zenodwikipedia/format/simpledetectionmethod/SPD_B_0.5/"
			// + gwi
			// +
			// "max0idx_max0fre_max1idx_max1fre_idxbreak_maxbreak_max2idx_max2fre_interval_rate_t1_"
			// + dwm + "_" + kk + "_" + h + ".txt";
			String filename = file.getName().split("_")[0];
			BufferedReader br = new BufferedReader(new InputStreamReader(
					new FileInputStream(file), "utf-8"));
			Map<String, Integer> mapti = new HashMap<String, Integer>();
			Map<Integer, Integer> mapti_real = new HashMap<Integer, Integer>();
			List<String> mapra = new ArrayList<String>();
			Map<String, Integer> mapt1 = new HashMap<String, Integer>();
			Map<Integer, Integer> mapta = new HashMap<Integer, Integer>();
			List<String> mapm1 = new ArrayList<String>();
			List<String> mapm2 = new ArrayList<String>();
			List<String> mapm10 = new ArrayList<String>();
			List<String> mapm20 = new ArrayList<String>();
			List<String> m1m2 = new ArrayList<String>();
			List<Integer> mappw1 = new ArrayList<Integer>();
			List<Integer> mappw2 = new ArrayList<Integer>();
			List<Integer> listleftwide1 = new ArrayList<Integer>();
			List<Integer> listrightwide1 = new ArrayList<Integer>();
			List<Integer> listleftwide2 = new ArrayList<Integer>();
			List<Integer> listrightwide2 = new ArrayList<Integer>();
			String str = "";
			while ((str = br.readLine()) != null) {
				String[] s = str.split("\t");
				String k = s[9].trim();
				if (mapti.containsKey(k)) {
					int t = mapti.get(k);
					mapti.put(k, t + 1);
				} else {
					mapti.put(k, 1);
				}

				int ta2 = Integer.parseInt(s[15].trim());
				int ts1 = Integer.parseInt(s[12].trim());
				int ta1 = Integer.parseInt(s[11].trim());
				int ts2 = Integer.parseInt(s[16].trim());
				int idx1 = Integer.parseInt(s[3].trim());
				int idx2 = Integer.parseInt(s[7].trim());
				int ti_real = ta2-ts1;
				if (mapti_real.containsKey(ti_real)) {
					int t = mapti_real.get(ti_real);
					mapti_real.put(ti_real, t + 1);
				} else {
					mapti_real.put(ti_real, 1);
				}
				listleftwide1.add(idx1-ta1);
				listrightwide1.add(ts1-idx1);
				listleftwide2.add(idx2-ta2);
				listrightwide2.add(ts2-idx2);
				String ra = s[10].trim();
				String t1 = s[11].trim();
				String t2 = s[15].trim();
				int ta = Integer.parseInt(t2) - Integer.parseInt(t1);
				if (mapta.containsKey(ta)) {
					int t = mapta.get(ta);
					mapta.put(ta, t + 1);
				} else {
					mapta.put(ta, 1);
				}
				if (Double.parseDouble(ra) < 1 && Double.parseDouble(ra) > 0) {
					mapra.add(ra);
				}
				if (mapt1.containsKey(t1)) {
					int t = mapt1.get(t1);
					mapt1.put(t1, t + 1);
				} else {
					mapt1.put(t1, 1);
				}
				mapm1.add(s[14]);
				mapm2.add(s[18]);
				mapm10.add(s[13]);
				mapm20.add(s[17]);
				m1m2.add(s[14] + "\t" + s[18]);
				mappw1.add(Integer.parseInt(s[12])-Integer.parseInt(s[11]));
				mappw2.add(Integer.parseInt(s[16])-Integer.parseInt(s[15]));
			}
			br.close();
			/*
			 * String pathoutti =
			 * "D:/data/zenodwikipedia/format/simpledetectionmethod/SPD_B_0.5/"
			 * + gwi + "_timeinterval_" + dwm + "_" + kk + "_" + h + ".txt";
			 */
			String pathoutti = "D:/experiment/sleep-beauty/empirical/statistics/"
					+ filename + "_ti.txt";
			List<Map.Entry<String, Integer>> list = new ArrayList<Map.Entry<String, Integer>>(
					mapti.entrySet());
			Collections.sort(list,
					new Comparator<Map.Entry<String, Integer>>() {
						public int compare(Map.Entry<String, Integer> o1,
								Map.Entry<String, Integer> o2) {
							int flag = Integer.parseInt(o2.getKey())
									- Integer.parseInt(o1.getKey());
							if (flag > 0)
								return -1;
							else if (flag == 0)
								return 0;
							else
								return 1;
						}
					});
			BufferedWriter bwti = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(pathoutti), "utf-8"));
			int count = 0;
			for (Map.Entry<String, Integer> entry : list) {
				if (count >= 5 && count < (list.size() - 8)) {
					bwti.append(entry.getKey() + "\t" + entry.getValue());
					bwti.newLine();
				}
				count++;
			}
			bwti.close();
			
			
			String pathoutti_real = "D:/experiment/sleep-beauty/empirical/statistics/"
					+ filename + "_ti_real.txt";
			List<Map.Entry<Integer, Integer>> list_real = new ArrayList<Map.Entry<Integer, Integer>>(
					mapti_real.entrySet());
			Collections.sort(list_real,
					new Comparator<Map.Entry<Integer, Integer>>() {
						public int compare(Map.Entry<Integer, Integer> o1,
								Map.Entry<Integer, Integer> o2) {
							int flag = o2.getKey()
									- o1.getKey();
							if (flag > 0)
								return -1;
							else if (flag == 0)
								return 0;
							else
								return 1;
						}
					});
			BufferedWriter bwti_real = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(pathoutti_real), "utf-8"));
			count = 0;
			for (Map.Entry<Integer, Integer> entry : list_real) {
				if (count >= 5 && count < (list_real.size() - 10)) {
					bwti_real.append(entry.getKey() + "\t" + entry.getValue());
					bwti_real.newLine();
				}
				count++;
			}
			bwti_real.close();
			// String pathoutra =
			// "D:/data/zenodwikipedia/format/simpledetectionmethod/SPD_B_0.5/"
			// + gwi + "_rate_" + dwm + "_" + kk + "_" + h + ".txt";
			String pathoutra = "D:/experiment/sleep-beauty/empirical/statistics/"
					+ filename + "_ra.txt";
			BufferedWriter bwra = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(pathoutra), "utf-8"));
			for (String key : mapra) {
				bwra.append(key);
				bwra.newLine();
			}
			bwra.close();
			/*
			 * String pathoutt1 =
			 * "D:/data/zenodwikipedia/format/simpledetectionmethod/SPD_B_0.5/"
			 * + gwi + "_t1interval_" + dwm + "_" + kk + "_" + h + ".txt";
			 */
			String pathoutt1 = "D:/experiment/sleep-beauty/empirical/statistics/"
					+ filename + "_t1.txt";
			BufferedWriter bwt1 = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(pathoutt1), "utf-8"));
			for (String key : mapt1.keySet()) {
				bwt1.append(key + "\t" + mapt1.get(key));
				bwt1.newLine();
			}
			bwt1.close();

			/*
			 * String pathoutm1 =
			 * "D:/data/zenodwikipedia/format/simpledetectionmethod/SPD_B_0.5/"
			 * + gwi + "_m1_" + dwm + "_" + kk + "_" + h + ".txt";
			 */
			String pathoutm1 = "D:/experiment/sleep-beauty/empirical/statistics/"
					+ filename + "_m1.txt";
			BufferedWriter bwm1 = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(pathoutm1), "utf-8"));
			int i = 0;
			DecimalFormat df = new DecimalFormat("0.0000");
			for (String key : mapm1) {
				if (Double.parseDouble(mapm10.get(i)) < Double.parseDouble(key)) {
					bwm1.append(mapm10.get(i)
							+ "\t"
							+ key
							+ "\t"
							+ df.format(1.0 * Double.parseDouble(mapm10.get(i))
									/ Double.parseDouble(key)));
					bwm1.newLine();
				}else{
					bwm1.append(mapm10.get(i)
							+ "\t"
							+ key
							+ "\t"
							+ "1");
					bwm1.newLine();
				}
				i++;
			}
			bwm1.close();

			/*
			 * String pathoutm2 =
			 * "D:/data/zenodwikipedia/format/simpledetectionmethod/SPD_B_0.5/"
			 * + gwi + "_m2_" + dwm + "_" + kk + "_" + h + ".txt";
			 */
			String pathoutm2 = "D:/experiment/sleep-beauty/empirical/statistics/"
					+ filename + "_m2.txt";
			BufferedWriter bwm2 = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(pathoutm2), "utf-8"));
			i = 0;
			for (String key : mapm2) {
				if (Double.parseDouble(mapm20.get(i)) < Double.parseDouble(key)) {
					bwm2.append(mapm20.get(i)
							+ "\t"
							+ key
							+ "\t"
							+ df.format(1.0 * Double.parseDouble(mapm20.get(i))
									/ Double.parseDouble(key)));
					// bwm2.append(key);
					bwm2.newLine();
				}else{
					bwm2.append(mapm20.get(i)
							+ "\t"
							+ key
							+ "\t"
							+ "1");
					// bwm2.append(key);
					bwm2.newLine();
				}	
				i++;
			}
			bwm2.close();
			/*
			 * String pathoutm1m2 =
			 * "D:/data/zenodwikipedia/format/simpledetectionmethod/SPD_B_0.5/"
			 * + gwi + "_m2_" + dwm + "_" + kk + "_" + h + "_m1_m2.txt";
			 */
			String pathoutm1m2 = "D:/experiment/sleep-beauty/empirical/statistics/"
					+ filename + "_m1_m2.txt";
			BufferedWriter bwm1m2 = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(pathoutm1m2), "utf-8"));
			for (String key : m1m2) {
				bwm1m2.append(key);
				// bwm2.append(key);
				bwm1m2.newLine();
				i++;
			}
			bwm1m2.close();
			/*
			 * String pathoutta =
			 * "D:/data/zenodwikipedia/format/simpledetectionmethod/SPD_B_0.5/"
			 * + gwi + "_timeawaken_" + dwm + "_" + kk + "_" + h + ".txt";
			 */
			String pathoutta = "D:/experiment/sleep-beauty/empirical/statistics/"
					+ filename + "_ta.txt";
			BufferedWriter bwta = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(pathoutta), "utf-8"));
			for (int key : mapta.keySet()) {
				bwta.append(key + "\t" + mapta.get(key));
				bwta.newLine();
			}
			bwta.close();
			
			String pathoutpw1 = "D:/experiment/sleep-beauty/empirical/statistics/"
					+ filename + "_pw1.txt";
			BufferedWriter bwpw1 = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(pathoutpw1), "utf-8"));
			for (int key : mappw1) {
				bwpw1.append(""+key);
				bwpw1.newLine();
			}
			bwpw1.close();
			String pathoutpw2 = "D:/experiment/sleep-beauty/empirical/statistics/"
					+ filename + "_pw2.txt";
			BufferedWriter bwpw2 = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(pathoutpw2), "utf-8"));
			for (int key : mappw2) {
				bwpw2.append(""+key);
				bwpw2.newLine();
			}
			bwpw2.close();
			
			String pathout_lw_rw = "D:/experiment/sleep-beauty/empirical/statistics/"
					+ filename + "_lw1_rw1_lw2_rw2.txt";
			BufferedWriter bw_lw_rw = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(pathout_lw_rw), "utf-8"));
			for (int ii=0;ii<listleftwide1.size();ii++) {
				double wr1 = 1.0*listrightwide1.get(ii)/listleftwide1.get(ii);
				double wr2 = 1.0*listrightwide2.get(ii)/listleftwide2.get(ii);
				listlr1.add(df.format(wr1));
				listlr2.add(df.format(wr2));
				listleftwide1_total.add(listleftwide1.get(ii));
				listrightwide1_total.add(listrightwide1.get(ii));
				listleftwide2_total.add(listleftwide2.get(ii));
				listrightwide2_total.add(listrightwide2.get(ii));
				bw_lw_rw.append(""+listleftwide1.get(ii)+"\t"+listrightwide1.get(ii)+"\t"+df.format(wr1)+"\t"+listleftwide2.get(ii)+"\t"+listrightwide2.get(ii)+"\t"+df.format(wr2));
				bw_lw_rw.newLine();
			}
			bw_lw_rw.close();
		}
		String pathoutlr1 = "D:/experiment/sleep-beauty/empirical/statistics/total_lr1.txt";
		String pathoutlr2 = "D:/experiment/sleep-beauty/empirical/statistics/total_lr2.txt";
		BufferedWriter bw_lr1 = new BufferedWriter(new OutputStreamWriter(
				new FileOutputStream(pathoutlr1), "utf-8"));
		BufferedWriter bw_lr2 = new BufferedWriter(new OutputStreamWriter(
				new FileOutputStream(pathoutlr2), "utf-8"));
		for(String lr1i:listlr1){
			bw_lr1.append(lr1i);
			bw_lr1.newLine();
		}
		bw_lr1.close();
		for(String lr1i:listlr2){
			bw_lr2.append(lr1i);
			bw_lr2.newLine();
		}
		bw_lr2.close();
		String pathoutw1 = "D:/experiment/sleep-beauty/empirical/statistics/total_w1.txt";
		String pathoutw2 = "D:/experiment/sleep-beauty/empirical/statistics/total_w2.txt";
		BufferedWriter bw_w1 = new BufferedWriter(new OutputStreamWriter(
				new FileOutputStream(pathoutw1), "utf-8"));
		BufferedWriter bw_w2 = new BufferedWriter(new OutputStreamWriter(
				new FileOutputStream(pathoutw2), "utf-8"));
		for (int ii=0;ii<listleftwide1_total.size();ii++) {
			bw_w1.append(listleftwide1_total.get(ii)+"\t"+listrightwide1_total.get(ii));
			bw_w1.newLine();
		}
		bw_w1.close();
		for (int ii=0;ii<listleftwide2_total.size();ii++) {
			bw_w2.append(listleftwide2_total.get(ii)+"\t"+listrightwide2_total.get(ii));
			bw_w2.newLine();
		}
		bw_w2.close();
	}
}
